<?php

use Zen\Payment\Api;

include_once(Mage::getConfig()->getModuleDir('helper', 'Zen') . '/payment-core/src/Util.php');
include_once(Mage::getConfig()->getModuleDir('helper', 'Zen') . '/payment-core/src/Paywall.php');

/**
 * Class Zen_Block_Redirect
 */
class Zen_Block_Redirect extends Mage_Core_Block_Template
{

	/**
	 * @var Zen_Model_PaymentMethod | null
	 */
	private $methodInstance = null;

	/**
	 * @return void
	 * @throws Mage_Core_Exception
	 * @throws Mage_Core_Model_Store_Exception
	 * @throws Varien_Exception
	 */
	public function initPayment()
	{
		$paymentData = $this->getMethodInstance()->getPaywallData();

		$api = new Api(
			$this->getMethodInstance()->getApiKey(),
			$this->getMethodInstance()->getEnvironment()
		);

		$paymentRequest = $api->createPayment(json_encode($paymentData));
		$paymentError = !$paymentRequest['success'];

		if (!$paymentError) {
			header('Location:' . $paymentRequest['body']['redirectUrl']);
		} else {
			header('Location:' . $paymentRequest['data']['body']['error']['redirectUrl']);
		}

		die();
	}

	/**
	 * @return Zen_Model_PaymentMethod
	 * @throws Mage_Core_Exception
	 */
	public function getMethodInstance()
	{
		if ($this->methodInstance === null) {
			$this->methodInstance = $this->_getOrder()->getPayment()->getMethodInstance();
		}

		return $this->methodInstance;
	}

	/**
	 * @return Mage_Sales_Model_Order | null
	 */
	protected function _getOrder()
	{
		$getOrder = $this->getOrder();
		if ($getOrder) {
			return $getOrder;
		}
		if ($orderIncrementId = Mage::getSingleton('checkout/session')->getLastRealOrderId()) {
			return Mage::getModel('sales/order')->loadByIncrementId($orderIncrementId);
		}

		return null;
	}

	/**
	 * @return string
	 * @throws Mage_Core_Exception
	 * @throws Varien_Exception
	 */
	public function getOrderId()
	{
		return $this->getMethodInstance()->getOrderId();
	}

}
